Index: LMDZ5/branches/testing/libf/phy1d/lmdz1d.F
===================================================================
--- LMDZ5/branches/testing/libf/phy1d/lmdz1d.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/phy1d/lmdz1d.F	(revision 1795)
@@ -6,9 +6,11 @@
       use dimphy
       use surface_data, only : type_ocean,ok_veget
-      use pbl_surface_mod, only : pbl_surface_init, pbl_surface_final
+      use pbl_surface_mod, only : ftsoil, pbl_surface_init,
+     $                            pbl_surface_final
       use fonte_neige_mod, only : fonte_neige_init, fonte_neige_final 
 
       use infotrac ! new
       use control_mod
+      USE indice_sol_mod
 
       implicit none
@@ -20,9 +22,10 @@
 #include "clesphys.h"
 #include "dimsoil.h"
-#include "indicesol.h"
+!#include "indicesol.h"
 
 #include "comvert.h"
 #include "compar1d.h"
 #include "flux_arp.h"
+#include "tsoilnudge.h"
 #include "fcg_gcssold.h"
 !!!#include "fbforcing.h"
@@ -86,6 +89,6 @@
 
         integer :: kmax = llm
-        integer nlev_max
-        parameter (nlev_max = 100)
+        integer nlev_max,llm700
+        parameter (nlev_max = 1000)
         real timestep, frac, timeit
         real height(nlev_max),tttprof(nlev_max),qtprof(nlev_max),
@@ -98,19 +101,23 @@
 c        integer :: forcing_type
         logical :: forcing_les     = .false.
-        logical :: forcing_armcu  = .false.
+        logical :: forcing_armcu   = .false.
         logical :: forcing_rico    = .false.
         logical :: forcing_radconv = .false.
         logical :: forcing_toga    = .false.
         logical :: forcing_twpice  = .false.
+        logical :: forcing_amma    = .false.
         logical :: forcing_GCM2SCM = .false.
         logical :: forcing_GCSSold = .false.
+        logical :: forcing_sandu   = .false.
+        logical :: forcing_astex   = .false.
+        logical :: forcing_fire    = .false.
         integer :: type_ts_forcing ! 0 = SST constant; 1 = SST read from a file
 !                                                            (cf read_tsurf1d.F)
 
 !vertical advection computation
-        real d_t_z(llm), d_q_z(llm)
-        real d_t_dyn_z(llm), d_q_dyn_z(llm)
-        real zz(llm)
-        real zfact
+!       real d_t_z(llm), d_q_z(llm)
+!       real d_t_dyn_z(llm), d_q_dyn_z(llm)
+!       real zz(llm)
+!       real zfact
 
 !flag forcings
@@ -129,5 +136,5 @@
       real :: pzero=1.e5
       real :: play (llm),zlay (llm),sig_s(llm),plev(llm+1)
-      real :: playd(llm),zlayd(llm)
+      real :: playd(llm),zlayd(llm),ap_amma(llm+1),bp_amma(llm+1),poub
 
 !---------------------------------------------------------------------
@@ -137,7 +144,9 @@
       integer :: iq
       real :: phi(llm)
-      real :: teta(llm),temp(llm),u(llm),v(llm)
+      real :: teta(llm),tetal(llm),temp(llm),u(llm),v(llm),w(llm)
+      real :: rlat_rad(1),rlon_rad(1)
       real :: omega(llm+1),omega2(llm),rho(llm+1)
       real :: ug(llm),vg(llm),fcoriolis
+      real :: sfdt, cfdt
       real :: du_phys(llm),dv_phys(llm),dt_phys(llm)
       real :: du_dyn(llm),dv_dyn(llm),dt_dyn(llm)
@@ -194,5 +203,5 @@
 !  Fichiers et d'autres variables
 !---------------------------------------------------------------------
-      real ttt
+      real ttt,bow,q1
       integer :: ierr,k,l,i,it=1,mxcalc
       integer jjmp1
@@ -250,10 +259,24 @@
 !             initial profiles from RICO files 
 !             LS convergence imposed from RICO files 
+!forcing_type = 6 ==> forcing_amma = .true.
+!             initial profiles from AMMA nc file 
+!             LS convergence, omega and surface fluxes imposed from AMMA file  
 !forcing_type = 40 ==> forcing_GCSSold = .true.
 !             initial profile from GCSS file
 !             LS convergence imposed from GCSS file
+!forcing_type = 59 ==> forcing_sandu = .true.
+!             initial profiles from sanduref file: see prof.inp.001
+!             SST varying with time and divergence constante: see ifa_sanduref.txt file
+!             Radiation has to be computed interactively
+!forcing_type = 60 ==> forcing_astex = .true.
+!             initial profiles from file: see prof.inp.001 
+!             SST,divergence,ug,vg,ufa,vfa varying with time : see ifa_astex.txt file
+!             Radiation has to be computed interactively
 !forcing_type = 61 ==> forcing_armcu = .true.
-!             initial profile from arm_cu file
-!             LS convergence imposed from arm_cu file
+!             initial profiles from file: see prof.inp.001 
+!             sensible and latent heat flux imposed: see ifa_arm_cu_1.txt
+!             large scale advective forcing & radiative tendencies applied below 1000m: see ifa_arm_cu_2.txt
+!             use geostrophic wind ug=10m/s vg=0m/s. Duration of the case 53100s 
+!             Radiation to be switched off
 !
       if (forcing_type .eq.0) THEN
@@ -269,6 +292,12 @@
       elseif (forcing_type .eq.5) THEN
        forcing_rico = .true.
+      elseif (forcing_type .eq.6) THEN
+       forcing_amma = .true.
       elseif (forcing_type .eq.40) THEN
        forcing_GCSSold = .true.
+      elseif (forcing_type .eq.59) THEN
+       forcing_sandu   = .true.
+      elseif (forcing_type .eq.60) THEN
+       forcing_astex   = .true.
       elseif (forcing_type .eq.61) THEN
        forcing_armcu = .true.
@@ -276,5 +305,5 @@
       else
        write (*,*) 'ERROR : unknown forcing_type ', forcing_type
-       stop 'Forcing_type should be 0,1,2,3 or 40'
+       stop 'Forcing_type should be 0,1,2,3,4,5,6 or 40,59,60,61'
       ENDIF
       print*,"forcing type=",forcing_type
@@ -286,5 +315,6 @@
 
         type_ts_forcing = 0
-        if (forcing_toga) type_ts_forcing = 1
+        if (forcing_toga .or. forcing_sandu .or. forcing_astex) 
+     :    type_ts_forcing = 1
 
 !---------------------------------------------------------------------
@@ -325,4 +355,6 @@
 c Special case for arm_cu which lasts less than one day : 53100s !! (MPL 20111026)
       IF(forcing_type .EQ. 61) fnday=53100./86400.
+c Special case for amma which lasts less than one day : 64800s !! (MPL 20120216)
+      IF(forcing_type .EQ. 6) fnday=64800./86400.
       annee_ref = anneeref
       mois = 1
@@ -334,17 +366,40 @@
       day_ini = day
       day_end = day_ini + nday
+
+      IF (forcing_type .eq.2) THEN
 ! Convert the initial date of Toga-Coare to Julian day
       call ymds2ju
      $ (year_ini_toga,mth_ini_toga,day_ini_toga,heure,day_ju_ini_toga)
 
+      ELSEIF (forcing_type .eq.4) THEN
 ! Convert the initial date of TWPICE to Julian day
       call ymds2ju
      $ (year_ini_twpi,mth_ini_twpi,day_ini_twpi,heure_ini_twpi
      $ ,day_ju_ini_twpi)
-
-! Convert the initial date of Arm_cu to Julian day
+      ELSEIF (forcing_type .eq.6) THEN
+! Convert the initial date of AMMA to Julian day
+      call ymds2ju
+     $ (year_ini_amma,mth_ini_amma,day_ini_amma,heure_ini_amma
+     $ ,day_ju_ini_amma)
+
+      ELSEIF (forcing_type .eq.59) THEN
+! Convert the initial date of Sandu case to Julian day
+      call ymds2ju
+     $   (year_ini_sandu,mth_ini_sandu,day_ini_sandu,
+     $    time_ini*3600.,day_ju_ini_sandu)
+
+      ELSEIF (forcing_type .eq.60) THEN
+! Convert the initial date of Astex case to Julian day
+      call ymds2ju
+     $   (year_ini_astex,mth_ini_astex,day_ini_astex,
+     $    time_ini*3600.,day_ju_ini_astex)
+
+      ELSEIF (forcing_type .eq.61) THEN
+
+! Convert the initial date of Arm_cu case to Julian day
       call ymds2ju
      $ (year_ini_armcu,mth_ini_armcu,day_ini_armcu,heure_ini_armcu
      $ ,day_ju_ini_armcu)
+      ENDIF
 
       daytime = day + time_ini/24. ! 1st day and initial time of the simulation 
@@ -418,5 +473,14 @@
 !!      preff= 1.01325e5
       preff = psurf
-      call disvert(pa,preff,ap,bp,dpres,presnivs,nivsigs,nivsig)
+      IF (ok_old_disvert) THEN
+        call disvert0(pa,preff,ap,bp,dpres,presnivs,nivsigs,nivsig)
+        print *,'On utilise disvert0'
+      ELSE
+        call disvert(pa,preff,ap,bp,dpres,presnivs,nivsigs,nivsig,
+     :                 scaleheight)
+        print *,'On utilise disvert'
+c       Nouvelle version disvert permettant d imposer ap,bp (modif L.Guez) MPL 18092012
+c       Dans ce cas, on lit ap,bp dans le fichier hybrid.txt
+      ENDIF
       sig_s=presnivs/preff
       plev =ap+bp*psurf
@@ -424,9 +488,17 @@
 ccc      zlay=-rd*300.*log(play/psurf)/rg ! moved after reading profiles
 
+      IF (forcing_type .eq. 59) THEN
+! pour forcing_sandu, on cherche l'indice le plus proche de 700hpa#3000m
       write(*,*) '***********************'
       do l = 1, llm
        write(*,*) 'l,play(l),presnivs(l): ',l,play(l),presnivs(l)
+       if (trouve_700 .and. play(l).le.70000) then
+         llm700=l
+         print *,'llm700,play=',llm700,play(l)/100.
+         trouve_700= .false.
+       endif
       enddo
       write(*,*) '***********************'
+      ENDIF
 
 c
@@ -460,5 +532,5 @@
 ! rday: defini dans suphel.F (86400.)
 ! day_ini: lu dans run.def (dayref)
-! rlat,rlon lus dans lmdz1d.def
+! rlat_rad,rlon-rad: transformes en radian de rlat,rlon lus dans lmdz1d.def (en degres)
 ! airefi,zcufi,zcvfi initialises au debut de ce programme
 ! rday,ra,rg,rd,rcpd declares dans YOMCST.h et calcules dans suphel.F
@@ -470,7 +542,10 @@
       zcufi=airefi
       zcvfi=airefi
+!
+      rlat_rad(:)=rlat(:)*rpi/180.
+      rlon_rad(:)=rlon(:)*rpi/180.
 
       call iniphysiq(ngrid,llm,rday,day_ini,timestep,
-     .     rlat,rlon,airefi,zcufi,zcvfi,ra,rg,rd,rcpd,1)
+     .     rlat_rad,rlon_rad,airefi,zcufi,zcvfi,ra,rg,rd,rcpd,(/1/))
       print*,'apres iniphysiq'
 
@@ -501,4 +576,17 @@
         agesno  = xagesno
         tsoil(:,:,:)=tsurf
+!------ AMMA 2e run avec modele sol et rayonnement actif (MPL 23052012)
+!       tsoil(1,1,1)=299.18
+!       tsoil(1,2,1)=300.08
+!       tsoil(1,3,1)=301.88
+!       tsoil(1,4,1)=305.48
+!       tsoil(1,5,1)=308.00
+!       tsoil(1,6,1)=308.00
+!       tsoil(1,7,1)=308.00
+!       tsoil(1,8,1)=308.00
+!       tsoil(1,9,1)=308.00
+!       tsoil(1,10,1)=308.00
+!       tsoil(1,11,1)=308.00
+!-----------------------------------------------------------------------
         call pbl_surface_init(qsol, fder, snsrf, qsurfsrf,
      &                                    evap, frugs, agesno, tsoil)
@@ -734,5 +822,6 @@
        endif
 
-       if (forcing_toga .or. forcing_GCSSold .or. forcing_twpice) then
+       if (forcing_toga .or. forcing_GCSSold .or. forcing_twpice
+     :    .or.forcing_amma) then
          fcoriolis=0.0 ; ug=0. ; vg=0.
        endif
@@ -748,4 +837,30 @@
      : -fcoriolis*(u(1:mxcalc)-ug(1:mxcalc))
 
+!!!!!!!!!!!!!!!!!!!!!!!!
+! Geostrophic wind
+!!!!!!!!!!!!!!!!!!!!!!!!
+       sfdt = sin(0.5*fcoriolis*timestep)
+       cfdt = cos(0.5*fcoriolis*timestep)
+!
+        du_age(1:mxcalc)= -2.*sfdt/timestep*
+     :          (sfdt*(u(1:mxcalc)-ug(1:mxcalc)) -
+     :           cfdt*(v(1:mxcalc)-vg(1:mxcalc))  )
+!!     : fcoriolis*(v(1:mxcalc)-vg(1:mxcalc))
+!
+       dv_age(1:mxcalc)= -2.*sfdt/timestep*
+     :          (cfdt*(u(1:mxcalc)-ug(1:mxcalc)) +
+     :           sfdt*(v(1:mxcalc)-vg(1:mxcalc))  )
+!!     : -fcoriolis*(u(1:mxcalc)-ug(1:mxcalc))
+!
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!         call  writefield_phy('dv_age' ,dv_age,llm)
+!         call  writefield_phy('du_age' ,du_age,llm)
+!         call  writefield_phy('du_phys' ,du_phys,llm)
+!         call  writefield_phy('u_tend' ,u,llm)
+!         call  writefield_phy('u_g' ,ug,llm)
+!
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!! Increment state variables
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
         u(1:mxcalc)=u(1:mxcalc) + timestep*(
      :              du_phys(1:mxcalc)
@@ -773,4 +888,13 @@
 
         teta=temp*(pzero/play)**rkappa
+!
+!---------------------------------------------------------------------
+!   Nudge soil temperature if requested
+!---------------------------------------------------------------------
+
+      IF (nudge_tsoil) THEN
+       ftsoil(1,isoil_nudge,:) = ftsoil(1,isoil_nudge,:) 
+     .  -timestep/tau_soil_nudge*(ftsoil(1,isoil_nudge,:)-Tsoil_nudge)
+      ENDIF
 
 !---------------------------------------------------------------------
Index: LMDZ5/branches/testing/libf/phy1d/ocean_forced_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phy1d/ocean_forced_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phy1d/ocean_forced_mod.F90	(revision 1795)
@@ -31,5 +31,6 @@
     USE limit_read_mod
     USE mod_grid_phy_lmdz
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
+!    INCLUDE "indicesol.h"
     INCLUDE "YOMCST.h"
 
@@ -145,6 +146,7 @@
     USE limit_read_mod
     USE fonte_neige_mod,  ONLY : fonte_neige
-
-    INCLUDE "indicesol.h"
+    USE indice_sol_mod
+
+!    INCLUDE "indicesol.h"
     INCLUDE "dimsoil.h"
     INCLUDE "YOMCST.h"
Index: LMDZ5/branches/testing/libf/phy1d/surf_land_bucket_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phy1d/surf_land_bucket_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phy1d/surf_land_bucket_mod.F90	(revision 1795)
@@ -26,9 +26,10 @@
     USE mod_grid_phy_lmdz
     USE mod_phys_lmdz_para
+    USE indice_sol_mod
 !****************************************************************************************
 ! Bucket calculations for surface. 
 !
     INCLUDE "clesphys.h"
-    INCLUDE "indicesol.h"
+!    INCLUDE "indicesol.h"
     INCLUDE "dimsoil.h"
     INCLUDE "YOMCST.h"
Index: LMDZ5/branches/testing/libf/phy1d/tsoilnudge.h
===================================================================
--- LMDZ5/branches/testing/libf/phy1d/tsoilnudge.h	(revision 1795)
+++ LMDZ5/branches/testing/libf/phy1d/tsoilnudge.h	(revision 1795)
@@ -0,0 +1,7 @@
+      logical nudge_tsoil
+      integer isoil_nudge
+      real Tsoil_nudge, tau_soil_nudge
+
+      common /tsoilnudge/ nudge_tsoil, isoil_nudge, Tsoil_nudge,        &
+     &                   tau_soil_nudge
+
Index: LMDZ5/branches/testing/libf/phydev/physiq.F90
===================================================================
--- LMDZ5/branches/testing/libf/phydev/physiq.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phydev/physiq.F90	(revision 1795)
@@ -75,4 +75,5 @@
 integer,save :: iwrite_phys ! output every iwrite_phys physics step
 !$OMP THREADPRIVATE(iwrite_phys)
+integer :: iwrite_phys_omp ! intermediate variable to read iwrite_phys
 real :: t_ops ! frequency of the IOIPSL operations (eg average over...)
 real :: t_wrt ! frequency of the IOIPSL outputs
@@ -86,6 +87,11 @@
 ! Initialize outputs:
   itau0=0
-  iwrite_phys=1 !default: output every physics timestep
-  call getin("iwrite_phys",iwrite_phys)
+!$OMP MASTER
+  iwrite_phys_omp=1 !default: output every physics timestep
+  ! NB: getin() is not threadsafe; only one thread should call it.
+  call getin("iwrite_phys",iwrite_phys_omp)
+!$OMP END MASTER
+!$OMP BARRIER
+  iwrite_phys=iwrite_phys_omp
   t_ops=pdtphys*iwrite_phys ! frequency of the IOIPSL operation
   t_wrt=pdtphys*iwrite_phys ! frequency of the outputs in the file
Index: LMDZ5/branches/testing/libf/phylmd/aero_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/aero_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/aero_mod.F90	(revision 1795)
@@ -5,5 +5,7 @@
 
   ! Total number of aerosols
-  INTEGER, PARAMETER :: naero_tot = 10 
+!  INTEGER, PARAMETER :: naero_tot = 10 
+!--STRAT AER
+  INTEGER, PARAMETER :: naero_tot = 11
 
   ! Identification number used in aeropt_2bands and aeropt_5wv
@@ -19,4 +21,7 @@
   INTEGER, PARAMETER :: id_AIBCM    = 9
   INTEGER, PARAMETER :: id_AIPOMM   = 10
+!--STRAT AER
+  INTEGER, PARAMETER :: id_strat   = 11
+
 
   ! Total number of aerosols actually used in LMDZ 
@@ -31,8 +36,11 @@
   ! 9 =  AIBCM
   !10 =  AIPOMM
-  INTEGER, PARAMETER :: naero_spc = 10
+!--STRAT AER
+  !11 = aerosols stratos
+!  INTEGER, PARAMETER :: naero_spc = 10
+  INTEGER, PARAMETER :: naero_spc = 11
 
   ! Corresponding names for the aerosols
-  CHARACTER(len=7),DIMENSION(naero_spc) :: name_aero=(/&
+  CHARACTER(len=7),DIMENSION(naero_spc), PARAMETER :: name_aero=(/&
        "ASBCM  ", &
        "ASPOMM ", &
@@ -44,5 +52,7 @@
        "CIDUSTM", &
        "AIBCM  ", &
-       "AIPOMM " /)
+!       "AIPOMM " /)
+       "AIPOMM ", &
+       "STRAT  " /)
 
 
@@ -65,4 +75,3 @@
   INTEGER, parameter :: nbands = 2
 
-
 END MODULE aero_mod
Index: LMDZ5/branches/testing/libf/phylmd/calbeta.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/calbeta.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/calbeta.F90	(revision 1795)
@@ -6,4 +6,5 @@
 
   USE dimphy
+  USE indice_sol_mod
   IMPLICIT none
 !======================================================================
@@ -13,7 +14,5 @@
 !
 ! Calculer quelques parametres pour appliquer la couche limite
-! ------------------------------------------------------------
-  INCLUDE "indicesol.h"
-  
+! ------------------------------------------------------------ 
 ! Variables d'entrees
 !****************************************************************************************
Index: LMDZ5/branches/testing/libf/phylmd/calcul_fluxs_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/calcul_fluxs_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/calcul_fluxs_mod.F90	(revision 1795)
@@ -12,4 +12,5 @@
     
     USE dimphy, ONLY : klon
+    USE indice_sol_mod
 
 ! Cette routine calcule les fluxs en h et q a l'interface et eventuellement
@@ -49,5 +50,4 @@
     INCLUDE "YOETHF.h"
     INCLUDE "FCTTRE.h"
-    INCLUDE "indicesol.h"
     INCLUDE "YOMCST.h"
 
Index: LMDZ5/branches/testing/libf/phylmd/calltherm.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/calltherm.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/calltherm.F90	(revision 1795)
@@ -17,7 +17,9 @@
      &      ,alp_bl_conv,alp_bl_stat &
 !!! fin nrlmd le 10/04/2012
-     &                    )
+     &      ,zqla,ztva )
 
       USE dimphy
+      USE indice_sol_mod
+
       implicit none
 #include "dimensions.h"
@@ -26,10 +28,8 @@
 #include "iniprint.h"
 
-!!! nrlmd le 10/04/2012
-#include "indicesol.h"
-!!! fin nrlmd le 10/04/2012
 
 !IM 140508
-      INTEGER itap
+      INTEGER, SAVE ::  itap
+!$OMP THREADPRIVATE(itap)
       REAL dtime
       LOGICAL debut
@@ -62,5 +62,5 @@
       real zqla(klon,klev)
       real zqta(klon,klev)
-      real ztv(klon,klev)
+      real ztv(klon,klev),ztva(klon,klev)
       real zpspsk(klon,klev)
       real ztla(klon,klev)
@@ -256,5 +256,5 @@
      &      ,alp_bl_conv,alp_bl_stat &
 !!! fin nrlmd le 10/04/2012
-     &                         )
+     &      ,ztva ) 
            if (prt_level.gt.10) write(lunout,*)'Apres thermcell_main OK'
          else
Index: LMDZ5/branches/testing/libf/phylmd/carbon_cycle_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/carbon_cycle_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/carbon_cycle_mod.F90	(revision 1795)
@@ -19,11 +19,14 @@
 !$OMP THREADPRIVATE(carbon_cycle_cpl)
 
+  LOGICAL :: carbon_cycle_emis_comp_omp=.FALSE.
   LOGICAL :: carbon_cycle_emis_comp=.FALSE. ! Calculation of emission compatible
 !$OMP THREADPRIVATE(carbon_cycle_emis_comp)
 
+  LOGICAL :: RCO2_inter_omp
   LOGICAL :: RCO2_inter  ! RCO2 interactive : if true calculate new value RCO2 for the radiation scheme
 !$OMP THREADPRIVATE(RCO2_inter)
 
 ! Scalare values when no transport, from physiq.def
+  REAL :: fos_fuel_s_omp
   REAL :: fos_fuel_s  ! carbon_cycle_fos_fuel dans physiq.def
 !$OMP THREADPRIVATE(fos_fuel_s)
@@ -112,6 +115,10 @@
     ! Read fosil fuel value if no transport
     IF (.NOT. carbon_cycle_tr) THEN
-       fos_fuel_s = 0.
-       CALL getin ('carbon_cycle_fos_fuel',fos_fuel_s)
+!$OMP MASTER
+       fos_fuel_s_omp = 0.
+       CALL getin ('carbon_cycle_fos_fuel',fos_fuel_s_omp)
+!$OMP END MASTER
+!$OMP BARRIER
+       fos_fuel_s=fos_fuel_s_omp
        WRITE(lunout,*) 'carbon_cycle_fos_fuel = ', fos_fuel_s 
     END IF
@@ -120,6 +127,10 @@
     ! Read parmeter for calculation compatible emission
     IF (.NOT. carbon_cycle_tr) THEN
-       carbon_cycle_emis_comp=.FALSE.
-       CALL getin('carbon_cycle_emis_comp',carbon_cycle_emis_comp)
+!$OMP MASTER
+       carbon_cycle_emis_comp_omp=.FALSE.
+       CALL getin('carbon_cycle_emis_comp',carbon_cycle_emis_comp_omp)
+!$OMP END MASTER
+!$OMP BARRIER
+       carbon_cycle_emis_comp=carbon_cycle_emis_comp_omp
        WRITE(lunout,*) 'carbon_cycle_emis_comp = ',carbon_cycle_emis_comp
        IF (carbon_cycle_emis_comp) THEN
@@ -129,6 +140,10 @@
 
     ! Read parameter for interactive calculation of the CO2 value for the radiation scheme
-    RCO2_inter=.FALSE.
-    CALL getin('RCO2_inter',RCO2_inter)
+!$OMP MASTER
+    RCO2_inter_omp=.FALSE.
+    CALL getin('RCO2_inter',RCO2_inter_omp)
+!$OMP END MASTER
+!$OMP BARRIER
+    RCO2_inter=RCO2_inter_omp
     WRITE(lunout,*) 'RCO2_inter = ', RCO2_inter
     IF (RCO2_inter) THEN
@@ -294,9 +309,9 @@
     USE phys_cal_mod, ONLY : day_cur
     USE comgeomphy
+    USE indice_sol_mod
 
     IMPLICIT NONE
 
     INCLUDE "clesphys.h"
-    INCLUDE "indicesol.h"
     INCLUDE "iniprint.h"
     INCLUDE "YOMCST.h"
Index: LMDZ5/branches/testing/libf/phylmd/change_srf_frac_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/change_srf_frac_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/change_srf_frac_mod.F90	(revision 1795)
@@ -28,7 +28,7 @@
     USE cpl_mod, ONLY : cpl_receive_frac
     USE ocean_slab_mod, ONLY : ocean_slab_frac
+    USE indice_sol_mod
 
     INCLUDE "iniprint.h"
-    INCLUDE "indicesol.h"
     INCLUDE "YOMCST.h"
 
Index: LMDZ5/branches/testing/libf/phylmd/clcdrag.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/clcdrag.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/clcdrag.F90	(revision 1795)
@@ -8,4 +8,6 @@
 
   USE dimphy
+  USE indice_sol_mod
+
   IMPLICIT NONE
 ! ================================================================= c
@@ -17,5 +19,5 @@
 !
 ! knon----input-I- nombre de points pour un type de surface
-! nsrf----input-I- indice pour le type de surface; voir indicesol.h
+! nsrf----input-I- indice pour le type de surface; voir indice_sol_mod.F90
 ! u1-------input-R- vent zonal au 1er niveau du modele
 ! v1-------input-R- vent meridien au 1er niveau du modele
@@ -41,5 +43,4 @@
   INCLUDE "YOMCST.h"
   INCLUDE "YOETHF.h"
-  INCLUDE "indicesol.h"
   INCLUDE "clesphys.h"
 !
Index: LMDZ5/branches/testing/libf/phylmd/clesphys.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/clesphys.h	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/clesphys.h	(revision 1795)
@@ -12,5 +12,5 @@
        LOGICAL cycle_diurne,soil_model,new_oliq,ok_orodr,ok_orolf 
        LOGICAL ok_limitvrai
-       INTEGER nbapp_rad, iflag_con
+       INTEGER nbapp_rad, iflag_con,iflag_ener_conserv
        REAL co2_ppm, co2_ppm0, solaire
        REAL(kind=8) RCO2, RCH4, RN2O, RCFC11, RCFC12  
@@ -79,4 +79,5 @@
        COMMON/clesphys/cycle_diurne, soil_model, new_oliq,              &
      &     ok_orodr, ok_orolf, ok_limitvrai, nbapp_rad, iflag_con       &
+     &     , iflag_ener_conserv                                         &
      &     , co2_ppm, solaire                                           &
      &     , RCO2, RCH4, RN2O, RCFC11, RCFC12                           &
Index: LMDZ5/branches/testing/libf/phylmd/cltracrn.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cltracrn.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/cltracrn.F90	(revision 1795)
@@ -9,4 +9,6 @@
   USE dimphy
   USE traclmdz_mod, ONLY : id_rn, id_pb
+  USE indice_sol_mod
+
   IMPLICIT NONE
 !======================================================================
@@ -44,5 +46,4 @@
 !======================================================================
   include "YOMCST.h"
-  include "indicesol.h"
 !
 !Entrees
Index: LMDZ5/branches/testing/libf/phylmd/coef_diff_turb_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/coef_diff_turb_mod.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/coef_diff_turb_mod.F90	(revision 1795)
@@ -17,4 +17,5 @@
  
     USE dimphy
+    USE indice_sol_mod
 !
 ! Calculate coefficients(ycoefm, ycoefh) for turbulent diffusion in the 
@@ -55,5 +56,4 @@
 !****************************************************************************************
     INCLUDE "clesphys.h"
-    INCLUDE "indicesol.h"
     INCLUDE "iniprint.h"
     INCLUDE "compbl.h"
@@ -158,10 +158,10 @@
          
 !   iflag_pbl peut etre utilise comme longuer de melange
-       IF (iflag_pbl.GE.18) THEN
+       IF (iflag_pbl.GE.31) THEN
           CALL vdif_kcay(knon,dtime,RG,RD,ypaprs,yt, &
                yzlev,yzlay,yu,yv,yteta, &
                ycdragm,yq2,q2diag,ykmm,ykmn,yustar, &
                iflag_pbl)
-       ELSE
+       ELSE IF (iflag_pbl<20) THEN
           CALL yamada4(knon,dtime,RG,RD,ypaprs,yt, &
                yzlev,yzlay,yu,yv,yteta, &
@@ -187,4 +187,5 @@
     
     USE dimphy
+    USE indice_sol_mod
   
 !======================================================================
@@ -211,5 +212,4 @@
     INCLUDE "FCTTRE.h"
     INCLUDE "iniprint.h"
-    INCLUDE "indicesol.h"
     INCLUDE "compbl.h"
     INCLUDE "YOMCST.h"
@@ -479,4 +479,5 @@
 
     USE dimphy
+    USE indice_sol_mod
 
 !======================================================================
@@ -523,5 +524,4 @@
     REAL zdthmin(knon), zdthdp
 
-    INCLUDE "indicesol.h"
     INCLUDE "YOMCST.h"
 !
Index: LMDZ5/branches/testing/libf/phylmd/coefcdrag.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/coefcdrag.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/coefcdrag.F90	(revision 1795)
@@ -6,4 +6,7 @@
                             ts, qsurf, rugos, okri, ri1, &
                             cdram, cdrah, cdran, zri1, pref)
+
+      USE indice_sol_mod
+
       IMPLICIT none
 !-------------------------------------------------------------------------
@@ -18,5 +21,5 @@
 ! klon----input-I- dimension de la grille physique (= nb_pts_latitude X nb_pts_longitude)
 ! knon----input-I- nombre de points pour un type de surface
-! nsrf----input-I- indice pour le type de surface; voir indicesol.h
+! nsrf----input-I- indice pour le type de surface; voir indice_sol_mod.F90
 ! zxli----input-L- TRUE si calcul des cdrags selon Laurent Li
 ! speed---input-R- module du vent au 1er niveau du modele
@@ -49,5 +52,4 @@
       include "YOMCST.h"
       include "YOETHF.h"
-      include "indicesol.h"
 ! Quelques constantes :
       REAL, parameter :: RKAR=0.40, CB=5.0, CC=5.0, CD=5.0, cepdu2=(0.1)**2
Index: LMDZ5/branches/testing/libf/phylmd/concvl.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/concvl.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/concvl.F	(revision 1795)
@@ -387,8 +387,9 @@
      $              dd_t,dd_q,Plim1,Plim2,asupmax,supmax0,
      $              asupmaxmin,lalim_conv,
-!AC!+!RomP
-     $              da,phi,mp,phi2,d1a,dam,sij,clw,  ! RomP
-     $              elij,evap,ep,wdtrainA,wdtrainM)  ! RomP
-!AC!+!RomP
+!AC!+!RomP+jyg
+     $              da,phi,mp,phi2,d1a,dam,sij,clw,elij,       ! RomP
+     $              evap,ep,epmlmMm,eplaMm,                    ! RomP
+     $              wdtrainA,wdtrainM)                         ! RomP
+!AC!+!RomP+jyg
       endif  
 C------------------------------------------------------------------
Index: LMDZ5/branches/testing/libf/phylmd/condsurf.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/condsurf.F	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/condsurf.F	(revision 1795)
@@ -5,4 +5,5 @@
       USE mod_grid_phy_lmdz
       USE mod_phys_lmdz_para
+      USE indice_sol_mod
       IMPLICIT none
 c
@@ -25,5 +26,4 @@
 cym#include "dimensions.h"
 cym#include "dimphy.h"
-#include "indicesol.h"
 #include "temps.h"
 #include "clesphys.h"
Index: LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 1750)
+++ LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 1795)
@@ -18,5 +18,5 @@
                        iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs, &
   		       ok_ade, ok_aie, ok_cdnc, aerosol_couple, &
-                       flag_aerosol, new_aod, &
+                       flag_aerosol, flag_aerosol_strat, new_aod, &
                        bl95_b0, bl95_b1,&
                        read_climoz, &
@@ -60,4 +60,5 @@
 ! ok_ade, ok_aie: apply or not aerosol direct and indirect effects
 ! ok_cdnc, ok cloud droplet number concentration
+! flag_aerosol_strat : flag pour les aerosols stratos
 ! bl95_b*: parameters in the formula to link CDNC to aerosol mass conc 
 !
@@ -72,4 +73,5 @@
   LOGICAL              :: ok_ade, ok_aie, ok_cdnc, aerosol_couple
   INTEGER              :: flag_aerosol
+  LOGICAL              :: flag_aerosol_strat
   LOGICAL              :: new_aod
   REAL                 :: bl95_b0, bl95_b1
@@ -87,4 +89,5 @@
   LOGICAL,SAVE        :: ok_ade_omp, ok_aie_omp, ok_cdnc_omp, aerosol_couple_omp
   INTEGER, SAVE       :: flag_aerosol_omp
+  LOGICAL, SAVE       :: flag_aerosol_strat_omp
   LOGICAL, SAVE       :: new_aod_omp
   REAL,SAVE           :: bl95_b0_omp, bl95_b1_omp
@@ -169,4 +172,5 @@
   LOGICAL,SAVE :: ok_orodr_omp, ok_orolf_omp, ok_limitvrai_omp
   INTEGER, SAVE :: nbapp_rad_omp, iflag_con_omp
+  INTEGER, SAVE :: iflag_ener_conserv_omp
   LOGICAL,SAVE :: ok_strato_omp
   LOGICAL,SAVE :: ok_hines_omp
@@ -306,4 +310,13 @@
   flag_aerosol_omp = 0
   CALL getin('flag_aerosol',flag_aerosol_omp)
+!
+!Config Key  = flag_aerosol_strat
+!Config Desc = use stratospheric aerosols T/F
+!Config Def  = false
+!Config Help = Used in physiq.F
+!
+!
+  flag_aerosol_strat_omp = .false.
+  CALL getin('flag_aerosol_strat',flag_aerosol_strat_omp)
 
 ! Temporary variable for testing purpose!!
@@ -653,4 +666,14 @@
        CALL getin('iflag_con',iflag_con_omp)
 
+!Config  Key  = iflag_ener_conserv
+!Config  Desc = Flag de convection
+!Config  Def  = 1
+!Config  Help = Flag  pour la convection les options suivantes existent :
+!Config         -1 pour Kinetic energy correction
+!Config         1  conservation kinetic and enthalpy
+       iflag_ener_conserv_omp = -1
+       CALL getin('iflag_ener_conserv',iflag_ener_conserv_omp)
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !!
@@ -1637,4 +1660,5 @@
     nbapp_rad = nbapp_rad_omp
     iflag_con = iflag_con_omp
+    iflag_ener_conserv = iflag_ener_conserv_omp
 
     epmax = epmax_omp
@@ -1705,4 +1729,5 @@
     aerosol_couple = aerosol_couple_omp
     flag_aerosol=flag_aerosol_omp
+    flag_aerosol_strat=flag_aerosol_strat_omp
     new_aod=new_aod_omp
     aer_type = aer_type_omp
@@ -1845,4 +1870,5 @@
   write(lunout,*)'nbapp_rad=',nbapp_rad
   write(lunout,*)'iflag_con=',iflag_con
+  write(lunout,*)'iflag_ener_conserv=',iflag_ener_conserv
   write(lunout,*)' epmax = ', epmax
   write(lunout,*)' ok_adj_ema = ', ok_adj_ema
@@ -1888,4 +1914,5 @@
   write(lunout,*)' aerosol_couple = ', aerosol_couple
   write(lunout,*)' flag_aerosol = ', flag_aerosol
+  write(lunout,*)' flag_aerosol_strat = ', flag_aerosol_strat
   write(lunout,*)' new_aod = ', new_aod
   write(lunout,*)' aer_type = ',aer_type
